###############################################################################
#	Filename:	PhasedTorp.py
#	By:		edtheborg
###############################################################################
# This torpedo uses my script torpedo mod...
#
# it actually passes through shields and damages the hull of any vessel
# this torpedo also demonstrates how to use the script torpedo mod
#
# please refer to the TargetHit routine at the very bottom of this file
# as this illustrates how to use a custom script for a torpedo
###############################################################################

import App

###############################################################################
#	Args:	pTorp - the torpedo, ready to be filled-in
#	
#	Return:	zero
###############################################################################
def Create(pTorp):
	kCoreColor = App.TGColorA()
	kCoreColor.SetRGBA(240.0 / 255.0, 0.0 / 255.0, 15.0 / 255.0, 1.000000)
	kGlowColor = App.TGColorA()
	kGlowColor.SetRGBA(100.0 / 255.0, 40.0 / 255.0, 40.0 / 255.0, 1.000000)
	kFlareColor = App.TGColorA()
	kFlareColor.SetRGBA(80.0 / 255.0, 60.0 / 255.0, 70.0 / 255.0, 1.000000)		

	pTorp.CreateTorpedoModel(
					"data/Textures/Tactical/TorpedoCore.tga",
					kCoreColor,
					0.2,
					1.0,	 
					"data/Textures/Tactical/TorpedoGlow.tga", 
					kGlowColor,
					4.0,	
					0.2,	 
					0.7,	
					"data/Textures/Tactical/TorpedoFlares.tga",
					kFlareColor,										
					6,		
					0.7,		
					0.4)

	pTorp.SetDamage( GetDamage() )
	pTorp.SetDamageRadiusFactor(0.19)
	pTorp.SetGuidanceLifetime( GetGuidanceLifetime() )
	pTorp.SetMaxAngularAccel( GetMaxAngularAccel() )

	# Multiplayer specific stuff.  Please, if you create a new torp
	# type. modify the SpeciesToTorp.py file to add the new type.
	import Multiplayer.SpeciesToTorp
	pTorp.SetNetType (Multiplayer.SpeciesToTorp.PHASEDPLASMA)

	return(0)

def GetLaunchSpeed():
	return(12)

def GetLaunchSound():
	return("Antimatter Torpedo")

def GetPowerCost():
	return(40.0)

def GetName():
	return("Phased Plasma")

def GetDamage():
	return 0.00001

def GetGuidanceLifetime():
	return 10.0

def GetMaxAngularAccel():
	return 0.11

# sets the damage the torpedo does to the hull
def GetYield():
	return 1900

def TargetHit(pObject, pEvent):
	pTarget=App.ShipClass_Cast(pEvent.GetDestination())
	Yield=GetYield
	pHull = pTarget.GetHull()
	if (pHull==None):
		return
	if (pHull.GetCondition()>Yield):
		pHull.SetCondition(pHull.GetCondition()-Yield)
		return
	pTarget.DestroySystem(pHull)
	return